program StringsEncoder;

{$APPTYPE CONSOLE}
{$R *.res}

uses
  Classes,
  SysUtils,
  StrUtils,
  SharedGlobal in '..\Misc\SharedGlobal.pas',
  GlobalLogger in '..\Misc\Logger\GlobalLogger.pas',
  ILogger in '..\Misc\Logger\ILogger.pas',
  LoggerParams in '..\Misc\Logger\LoggerParams.pas',
  EmptyLogger in '..\Misc\Logger\EmptyLogger.pas';

var
  txtDir: String;
  outFile: String;
  dirList: TStringList;
  sr: TSearchRec;
  i: integer;
  outList: TStringList;
  inList: TStringList;
  fname: String;
  key: Word;
  encodedString: String;
  encodedLine: String;
  needPlus: boolean;
  fullString: string;

const
  COutUnitName = 'EncStrings';
  COutFileName = COutUnitName + '.pas';
  CMaxLineSymCount = 50;

begin
  if ParamCount < 2 then
    Exit;

  Randomize;

  // txtDir := '../../../strings' + '/';
  // outFile := '../../..' + '/' + COutFileName;

  txtDir := ExpandFileName(ParamStr(1)) + '/';
  outFile := ExpandFileName(ParamStr(2)) + '/' + COutFileName;
  dirList := TStringList.Create;
  outList := TStringList.Create;
  inList := TStringList.Create;

  outList.Append('Unit ' + COutUnitName + ';');
  outList.Append('');
  outList.Append('{$RTTI EXPLICIT METHODS([]) PROPERTIES([]) FIELDS([])}');
  outList.Append('');
  outList.Append('interface');
  outList.Append('');
  outList.Append('const');

  try
    if FindFirst(txtDir + '*.txt', faAnyFile, sr) = 0 then
    begin
      repeat
        dirList.Add(sr.Name); // Fill the list
      until FindNext(sr) <> 0;

      FindClose(sr);
    end;

    for i := 0 to dirList.Count - 1 do
    begin
      inList.Clear;
      fname := dirList[i];
      inList.LoadFromFile(txtDir + fname);
      fname := fname.Remove(fname.Length - 4);
      key := Random(High(Word));

      outList.Append('    C' + fname.toUpper + '_KEY = ' + IntToStr(key) + ';');

      fullString := inList.Text;

      if fullString.EndsWith(sLineBreak) then
        fullString := fullString.Substring(0, fullString.Length - 2);

      encodedString := EncString(fullString, key, True);
      outList.Append('    C' + fname.toUpper + '_STRING = ');
      needPlus := False;

      repeat
        encodedLine := encodedString.Substring(0, CMaxLineSymCount);
        encodedString := encodedString.Substring(CMaxLineSymCount);
        outList.Append('        ' + StrUtils.IfThen(needPlus, ' + ', '   ') +
          '''' + encodedLine + '''');
        needPlus := True;
      until (encodedString.Length <= 0);

      outList[outList.Count - 1] := outList[outList.Count - 1] + ';';
    end;

    outList.Append('');
    outList.Append('implementation');
    outList.Append('');
    outList.Append('end.');

    outList.SaveToFile(outFile);
  except
  end;

  FreeAndNil(dirList);
  FreeAndNil(outList);
  FreeAndNil(inList);

end.
