unit mySecSharedFuncUnit;

interface

uses
  Winapi.Windows, SHDocVw, Vcl.ComCtrls;

  const binDir='bin\';
    getExternalIPPath='bin\getExternalIP.exe';
    getExternalIPsubstr='externalIP:';

  var appdir:string;

  function EncString(const sSomeString: string; Key: Word; enc: Boolean): string;
  function GetHttpByProxy(link:string;ipProxy:string='';portProxy:word=0):String;
  function GetExternalIP(ip:string='';port:word=0):String;
  function GetLocalIPs: string;
  function Between(s,sB,sE:String; els:string='0'; posit:PDWORD=nil):String;
  procedure WB_LoadHTML(WebBrowser: TWebBrowser; HTMLCode: string);
  procedure WebBrowser2IE9;
  procedure AutoWidth(ListView: TListView);
  function ExecWaitShowPath(aCmd: string;
    WaitTimeOut: cardinal = INFINITE;showing:boolean=false;path:string=''): cardinal;


implementation

uses IdHttp, IdSSLOpenSSL, idsocks, strutils, System.SysUtils, Winapi.WinSock,
  System.Classes, Vcl.Forms, Winapi.CommCtrl, MSHTML, System.Variants,
  Winapi.ActiveX, System.Win.Registry;

const
  STRING_ENC_KEY1 = 40152;
  STRING_ENC_KEY2 = 87318;

function Crypt(orig: TBytes; Key: Word; enc: Boolean): TBytes;
var
  i: integer;
  tmpKey: Int64;
  b:byte;
begin
  SetLength(Result, Length(orig));
  tmpKey := Key;
  for i := Low(orig) to High(orig) do begin
    b:=Byte(tmpKey shr 8);
    Result[i] := orig[i] xor b;
    if enc then
      tmpKey := Int64((Result[i] + tmpKey) * STRING_ENC_KEY1 + STRING_ENC_KEY2)
    else
      tmpKey := Int64((orig[i] + tmpKey) * STRING_ENC_KEY1 + STRING_ENC_KEY2)
  end;
end;

function EncString(const sSomeString: string; Key: Word; enc: Boolean): string;
var
  bytes: TBytes;
  i: integer;
  tmpStr: String;
  hexStr: string;
begin
  Result := '';
  if (enc) then begin
    bytes := TEncoding.UTF8.GetBytes(sSomeString);
    bytes := Crypt(bytes, Key, True);
    for i := Low(bytes) to High(bytes) do
      Result := Result + IntToHex(bytes[i], 2);
  end else begin
    tmpStr := sSomeString;
    i := 0;
    SetLength(bytes, Trunc(Length(tmpStr) / 2));
    while (Length(tmpStr) >= 2) do begin
      hexStr := '$' + tmpStr[1] + tmpStr[2];
      try
        bytes[i] := Byte(StrToInt(hexStr));
      except
        bytes[i] := 0;
      end;
      Inc(i);
      tmpStr := tmpStr.Substring(2);
    end;
    bytes := Crypt(bytes, Key, False);
    try
      Result := TEncoding.UTF8.GetString(bytes);
    except
    end;
  end;
end;

function ExecWaitShowPath(aCmd: string;
  WaitTimeOut: cardinal = INFINITE;showing:boolean=false;path:string=''): cardinal;
var
  si: STARTUPINFO;
  pi: PROCESS_INFORMATION;
  res: BOOL;
  r: cardinal;
  p: PWideChar;
  tCmd:string;
  Reason: DWORD;
begin
  tCmd:=aCMD;
  result := 0;
  r := 1;
  try
    with si do
    begin
      cb := sizeof(si);
      lpReserved := nil;
      lpDesktop := nil;
      lpTitle := PWideChar('External program');
      if showing then begin
        dwFlags := 0;//STARTF_USESHOWWINDOW;//0;
      end else begin
        dwFlags := STARTF_USESHOWWINDOW;//0;
      end;
      cbReserved2 := 0;
      lpReserved2 := nil;
      if showing then begin
        wShowWindow := SW_NORMAL;
      end else begin
        wShowWindow := SW_HIDE;
      end;
    end;
    UniqueString(tCmd);
    p := PChar( tCmd);
    if showing then begin
      if path<>'' then begin
        res := CreateProcess(nil, p, nil, nil, false, {CREATE_NEW_PROCESS_GROUP +
          HIGH_PRIORITY_CLASS}NORMAL_PRIORITY_CLASS, nil, PChar(path), si, pi);
      end else begin
        res := CreateProcess(nil, p, nil, nil, false, {CREATE_NEW_PROCESS_GROUP +
          HIGH_PRIORITY_CLASS}NORMAL_PRIORITY_CLASS, nil, nil, si, pi);
      end;
    end else begin
      if path<>'' then begin
        res := CreateProcess(nil, p, nil, nil, false, {CREATE_NEW_PROCESS_GROUP +
          HIGH_PRIORITY_CLASS}NORMAL_PRIORITY_CLASS + CREATE_NO_WINDOW, nil,
          PChar(path), si, pi);
      end else begin
        res := CreateProcess(nil, p, nil, nil, false, {CREATE_NEW_PROCESS_GROUP +
          HIGH_PRIORITY_CLASS}NORMAL_PRIORITY_CLASS + CREATE_NO_WINDOW, nil,
          nil, si, pi);
      end;
    end;
    if res then begin
      WaitForInputIdle(pi.hProcess, INFINITE); //   
      if WaitTimeOut<>0 then begin
        repeat
          {if (Application.MainForm<>nil) and (Application.MainForm.Showing) then
            Application.ProcessMessages;}
          Reason := WaitForSingleObject(pi.hProcess, 10);
          WaitTimeOut:=WaitTimeOut-10;
        until (Reason <> WAIT_TIMEOUT) or (WaitTimeOut<=0);
        GetExitCodeProcess(pi.hProcess, r);
        result := r;
      end;
      CloseHandle(pi.hThread); //   
      CloseHandle(pi.hProcess); //   
    end;
  except
  end;
end;

procedure AutoWidth(ListView: TListView);
var
  Col,Wid:Integer;
begin
  ListView.Items.BeginUpdate;
  {only if you want autosized columns or if any column.width=-1}
  for Col := 0 to ListView.Columns.Count - 1 do
    ListView.Columns[Col].Width := 0;

{ this is only needed for automatically setting the widths of the columns}
  for Col := 0 to ListView.Columns.Count - 1 do
  begin
    { autowidth by text in columns }
    ListView.Columns[Col].Width := -1;
    Wid := ListView_GetColumnWidth(ListView.handle, Col);

    { autowidth by text in headers }
    ListView.Columns[Col].Width := -2;
    if ListView_GetColumnWidth(ListView.handle, Col) > Wid then
      Wid := ListView_GetColumnWidth(ListView.handle, Col);

    { the wider of the two }
    ListView.Columns[Col].Width := Wid;
  end; { for }
{ end of autowidth code}
  ListView.Items.EndUpdate;
end;

procedure WB_LoadHTML(WebBrowser: TWebBrowser; HTMLCode: string);
var
  sl: TStringList;
  ms: TMemoryStream;

  Document: IHTMLDocument2;
  V: OleVariant;
begin
//  WebBrowser.Navigate('about:blank');
//  while WebBrowser.ReadyState < READYSTATE_INTERACTIVE do
//    Application.ProcessMessages;
//
//  if Assigned(WebBrowser.Document) then
//  begin
//    sl := TStringList.Create;
//    try
//      ms := TMemoryStream.Create;
//      try
//        sl.Text := HTMLCode;
//        sl.SaveToStream(ms);
//        ms.Seek(0, 0);
//        (WebBrowser.Document as
//          IPersistStreamInit).Load(TStreamAdapter.Create(ms));
//      finally
//        ms.Free;
//      end;
//    finally
//      sl.Free;
//    end;
//  end;

if WebBrowser.Document = nil then
WebBrowser.Navigate('about:blank');

while WebBrowser.Document = nil do
Application.ProcessMessages;
Document := WebBrowser.Document as IHtmlDocument2;
V := VarArrayCreate([0, 0], varVariant);

V[0] := HTMLCode;
Document.Write(PSafeArray(TVarData(v).VArray));
Document.Close;
end;

procedure WebBrowser2IE9;
const
code=9001;
//code=9001;
//code=11000;//$2AF9
//code=9000;//$2328
Var Reestr: TRegistry;
  progname:string;
begin
 progname := ExtractFileName( paramstr(0) );
 Reestr:=TRegistry.Create;
 Reestr.RootKey:=HKEY_CURRENT_USER;
 If Reestr.OpenKey('\SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION', true) Then Begin
   Reestr.WriteInteger(progName, code);
   Reestr.CloseKey;
 End;
 Reestr.RootKey:=HKEY_LOCAL_MACHINE;
 If Reestr.OpenKey('\SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION', true) Then
   Begin
     Reestr.WriteInteger(progName, code);
     Reestr.CloseKey;
   End;
 If Reestr.OpenKey('\SOFTWARE\Wow6432Node\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION', true) Then
   Begin
     Reestr.WriteInteger(progName, code);
     Reestr.CloseKey;
   End;
 Reestr.Free;
end;

function Between(s,sB,sE:String; els:string='0'; posit:PDWORD=nil):String;
var
  k1,k2:integer;
begin
  Result:=els;
  if posit=nil then
  k1:=PosEx(sB,s) else k1:=PosEx(sB,s,posit^);
  if k1=0 then exit;
  k1:=k1+length(sB);
  k2:=PosEx(sE,s,k1);
  if k2=0 then Exit;
  Result:=copy(s,k1,k2-k1);
  if posit<>nil then posit^:=k2;
end;

function GetHttpByProxy(link:string;ipProxy:string='';portProxy:word=0):String;
var IdHttp:TIdHttp; s:String;
  IdSSLIOHandlerSocketOpenSSL:TIdSSLIOHandlerSocketOpenSSL;
  IdSocksInfo:TIdSocksInfo;
begin
  s:='';
  IdHttp:=TIdHttp.Create(nil);
  IdSSLIOHandlerSocketOpenSSL:=TIdSSLIOHandlerSocketOpenSSL.Create(idhttp);
  IdSocksInfo:=TIdSocksInfo.Create(IdSSLIOHandlerSocketOpenSSL);
  try
  try
  IdHttp.ConnectTimeout:=10000;
  //IdSSLIOHandlerSocketOpenSSL.SSLOptions.Method := sslvSSLv23;
  if ipProxy<>'' then begin
    IdSocksInfo.Authentication:=saNoAuthentication;
    IdSocksInfo.Host:=ifthen(ipProxy='0.0.0.0','127.0.0.1',ipProxy);
    IdSocksInfo.Port:=portProxy;
    IdSocksInfo.Version:= svSocks5;
    IdSSLIOHandlerSocketOpenSSL.TransparentProxy.Assign(IdSocksInfo);
    //IdSSLIOHandlerSocketOpenSSL.SSLOptions.Method:=sslvSSLv23;
    //IdSSLIOHandlerSocketOpenSSL.SSLOptions.SSLVersions:=[sslvSSLv2,sslvSSLv3,sslvTLSv1,sslvTLSv1_1,sslvTLSv1_2];
  end;
  IdHTTP.IOHandler:=IdSSLIOHandlerSocketOpenSSL;
  s := IdHttp.Get(link);
  s := Trim(s);
 except
 end;
 finally
 FreeAndNil(IdSocksInfo);
 FreeAndNil(IdSSLIOHandlerSocketOpenSSL);
 FreeAndNil(IdHttp);
 end;
 Result:=s;
end;

function GetExternalIP(ip:string='';port:word=0):String;
var IdHttp:TIdHttp; s:String;
  IdSSLIOHandlerSocketOpenSSL:TIdSSLIOHandlerSocketOpenSSL;
  IdSocksInfo:TIdSocksInfo;
begin
  s:='0.0.0.0';
  IdHttp:=TIdHttp.Create(nil);
  IdSSLIOHandlerSocketOpenSSL:=TIdSSLIOHandlerSocketOpenSSL.Create(idhttp);
  IdSocksInfo:=TIdSocksInfo.Create(IdSSLIOHandlerSocketOpenSSL);
  try
  try
  IdHttp.ConnectTimeout:=10000;
  IdSSLIOHandlerSocketOpenSSL.SSLOptions.Method := sslvSSLv23;
  if ip<>'' then begin
    IdSocksInfo.Authentication:=saNoAuthentication;
    IdSocksInfo.Host:=ifthen(ip='0.0.0.0','127.0.0.1',ip);
    IdSocksInfo.Port:=port;
    IdSocksInfo.Version:= svSocks5;
    IdSSLIOHandlerSocketOpenSSL.TransparentProxy.Assign(IdSocksInfo);
  end;
  IdHTTP.IOHandler:=IdSSLIOHandlerSocketOpenSSL;
  s := IdHttp.Get('https://cmyip.com/');
  s := between(s, 'My IP Address is ', '<a');
  s := Trim(s);
 except
 on e:exception do
 end;
 finally
 FreeAndNil(IdSocksInfo);
 FreeAndNil(IdSSLIOHandlerSocketOpenSSL);
 FreeAndNil(IdHttp);
 end;
 Result:=s;
end;

function GetLocalIPs: string;
type
  TaPInAddr = Array[0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var
  phe: PHostEnt;
  pptr: PaPInAddr;
  Buffer: array [0..127] of AnsiChar;
  I: Integer;
  GInitData: TWSAData;
  IPs: TStringList;
begin
  IPs := TStringList.Create;
  try
  WSAStartup($101, GInitData);
  GetHostName(@Buffer, SizeOf(Buffer));
  phe := GetHostByName(@buffer);
  if phe = nil then {IPs.Add('No IP found')}
  else
  begin
    pPtr := PaPInAddr(phe^.h_addr_list);
    I := 0;
    while pPtr^[I] <> nil do
    begin
      IPs.Add(inet_ntoa(pptr^[I]^));
      Inc(I);
    end;
  end;
  WSACleanup;
  Result := IPs.Text;
  except
  result:='';
  end;
  freeandnil(IPs);
end;

initialization
appdir:=extractFilePath(application.exename);

end.
