unit wifiFuncUnit;

interface

uses System.Generics.Collections, nduWlanTypes, Winapi.Windows, nduWlanAPI,
  SHDocVw, Vcl.ComCtrls;

type
TGPS = record
  latitude : string;
  longitude : string;
end;
TwifiHotSpotInfo = class
  ssid : string;
  mac : string;
  gps : TGPS;
end;
TwifiHotSpotInfos = TObjectList<TwifiHotSpotInfo>;
procedure GetBSSIDList(var wifiHotSpotInfos:TwifiHotSpotInfos;
  clientHandle  : THandle; interfaceGUID : TGUID;
  pSSID         : Pndu_DOT11_SSID = nil;
  SSID_Type     : Tndu_DOT11_BSS_Type = dot11_BSS_type_any;
  SecurityEnabled : BOOL = True);
function getWLANInterfaces(var hWlan: THandle;
  var pInterfaceList: Pndu_WLAN_INTERFACE_INFO_LIST):boolean;
procedure freeWLANInterfaces(var pInterfaceList: Pndu_WLAN_INTERFACE_INFO_LIST);

implementation

uses
  nduCType, System.SysUtils,
  mySecSharedFuncUnit, strutils, System.Classes, MSHTML, Vcl.Forms,
  System.Variants, Winapi.ActiveX, System.Win.Registry;

function wifiConnected(clientHandle  : THandle; interfaceGUID : TGUID):boolean;
var
  isConnected: Boolean;
  pData         : Pndu_WLAN_INTERFACE_STATE;
  pdwDataSize   : DWORD;
begin
  //check if interface is connected
  isConnected := true;//False;
  if WlanQueryInterface(clientHandle,
                        @interfaceGUID,
                        wlan_intf_opcode_interface_state,
                        nil,
                        @pdwDataSize,
                        @pData,
                        nil) = ERROR_SUCCESS then begin
    isConnected := (pData^ = Tndu_WLAN_INTERFACE_STATE.wlan_interface_state_connected);
  end;
  result:=isConnected
end;

procedure GetBSSIDList(var wifiHotSpotInfos:TwifiHotSpotInfos;
  clientHandle  : THandle; interfaceGUID : TGUID;
  pSSID         : Pndu_DOT11_SSID = nil;
  SSID_Type     : Tndu_DOT11_BSS_Type = dot11_BSS_type_any;
  SecurityEnabled : BOOL = True);
var
  //to get list of BSSids from available APs
  pWlanBssList : Pndu_WLAN_BSS_LIST;
  items         : integer;
  itemIndex     : integer;
  SSID          : string;
  MAC           : string;
  gpsResult,gpslat,gpslon:string;
  wifiHotSpotInfo:TwifiHotSpotInfo;
begin
  if WlanGetNetworkBssList(clientHandle,@interfaceGUID,pSSID,SSID_Type,
    SecurityEnabled,nil,@pWlanBssList) = ERROR_SUCCESS then begin
    items := pWlanBssList^.dwNumberOfItems;
    for itemIndex := 0 to items - 1 do begin
      SSID := String(PAnsiChar(@pWlanBssList^.wlanBssEntries[itemIndex].dot11Ssid.ucSSID));
      MAC := Format('%.2x:%.2x:%.2x:%.2x:%.2x:%.2x', [
        pWlanBssList^.wlanBssEntries[itemIndex].dot11Bssid[0],
        pWlanBssList^.wlanBssEntries[itemIndex].dot11Bssid[1],
        pWlanBssList^.wlanBssEntries[itemIndex].dot11Bssid[2],
        pWlanBssList^.wlanBssEntries[itemIndex].dot11Bssid[3],
        pWlanBssList^.wlanBssEntries[itemIndex].dot11Bssid[4],
        pWlanBssList^.wlanBssEntries[itemIndex].dot11Bssid[5]]);
      //gpsResult:=wifiMainForm.idhttp1.get('https://api.mylnikov.org/geolocation/wifi?bssid='+MAC+'&data=open&v=1.1');
      gpsResult:=GetHttpByProxy('http://mobile.maps.yandex.net/cellid_location/?clid=1866854&lac=-1&cellid=-1&operatorid=null&countrycode=null&signalstrength=-1&wifinetworks='+
        replacestr(mac,':','')+':-65&app=ymetro');
      gpslat:=between(gpsResult,'latitude="','"','*');
      gpslon:=between(gpsResult,'longitude="','"','*');
//      Writeln('SSID: ................ '+SSID);
//      Writeln('Physical Address: .... '+MAC);
//      Writeln('GPS: ................. '+gpslat+','+gpslon);
//      Writeln('');
      wifiHotSpotInfo:=TwifiHotSpotInfo.Create;
      wifiHotSpotInfo.ssid:=SSID;
      wifiHotSpotInfo.mac:=mac;
//      if FormatSettings.DecimalSeparator<>'.' then begin
//        gpslat:=replacestr(gpslat,'.',FormatSettings.DecimalSeparator);
//        gpslon:=replacestr(gpslon,'.',FormatSettings.DecimalSeparator);
//      end;
      wifiHotSpotInfo.gps.latitude:=gpslat;
      wifiHotSpotInfo.gps.longitude:=gpslon;
      wifiHotSpotInfos.add(wifiHotSpotInfo);
    end; {for itemIndex}
  end; {WlanGetNetworkBssList succeeds}
end;

procedure freeWLANInterfaces(var pInterfaceList: Pndu_WLAN_INTERFACE_INFO_LIST);
begin
  if pInterfaceList<>nil then WlanFreeMemory(pInterfaceList);
end;

function getWLANInterfaces(var hWlan: THandle;
  var pInterfaceList: Pndu_WLAN_INTERFACE_INFO_LIST):boolean;
const
  WLAN_AVAILABLE_NETWORK_INCLUDE_ALL_ADHOC_PROFILES = $00000001;
var
  dwSupportedVersion: DWORD;
  //dwClientVersion: DWORD;
  //i,j                   : integer;
  //pInterfaceInfo        : Pndu_WLAN_INTERFACE_INFO;
  //pAvailableNetworkList : Pndu_WLAN_AVAILABLE_NETWORK_LIST;
begin
  result:=false;
  dwSupportedVersion:=0;//dwClientVersion:=1;
  hWlan := 0;
  if WlanOpenHandle(2, nil,@dwSupportedVersion, @hWlan)<> ERROR_SUCCESS then exit;
  if WlanEnumInterfaces(hWlan, nil, @pInterfaceList) = ERROR_SUCCESS then exit(true);

//  if WlanOpenHandle(2, nil,@dwSupportedVersion, @hWlan)= ERROR_SUCCESS then
//  begin
//    if WlanEnumInterfaces(hWlan, nil, @pInterfaceList) = ERROR_SUCCESS then
//    begin
//      try
//        for i := 0 to pInterfaceList^.dwNumberOfItems-1 do
//          begin
//            Writeln('Wifi Adapter - '+GUIDToString( pInterfaceList^.InterfaceInfo[i].InterfaceGuid ) );
//            Writeln('Scanning: .... '+pInterfaceList^.InterfaceInfo[i].strInterfaceDescription);
//            guid := pInterfaceList^.InterfaceInfo[i].InterfaceGuid;
//
//            //writeln('Get all BSSids for this interface');
//            GetBSSIDList(hWlan, guid);
//
////            if WlanGetAvailableNetworkList(hWlan,
////                                           @guid,
////                                           WLAN_AVAILABLE_NETWORK_INCLUDE_ALL_ADHOC_PROFILES,
////                                           nil,
////                                           pAvailableNetworkList) = ERROR_SUCCESS then begin
////              try
////                writeln('');writeln('');writeln('');
////                writeln('Get uses BSSid');
////                for j := 0 to pAvailableNetworkList^.dwNumberOfItems - 1 do begin
////
////                  //Get BSSid for this specific SSID
////                  GetBSSIDList(hWlan,
////                               guid,
////                               @pAvailableNetworkList^.Network[j].dot11Ssid,
////                               pAvailableNetworkList^.Network[j].dot11BssType,
////                               pAvailableNetworkList^.Network[j].bSecurityEnabled);
////
////                end;
////              finally
////                if pAvailableNetworkList<>nil then
////                  WlanFreeMemory(pAvailableNetworkList);
////              end;
////            end;
//
//          end;
//      finally
//        if pInterfaceList<>nil then
//          WlanFreeMemory(pInterfaceList);
//      end;
//    end;
//
//    WlanCloseHandle(hWlan, nil);
//
//    //readln;

//  end;
end;

initialization



end.
