unit wifiSecMainUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, IdIOHandler,
  IdIOHandlerSocket, IdIOHandlerStack, IdSSL, IdSSLOpenSSL, wifiFuncUnit,
  Vcl.ComCtrls, Vcl.OleCtrls, SHDocVw, GMGeoCode, GMMap, GMLinkedComponents,
  GMMarker, GMMarkerVCL, GMClasses, GMMapVCL, GMInfoWindow, Vcl.ExtCtrls,
  WMEXTENALIPUnit;

type
  TwifiMainForm = class(TForm)
    Button: TButton;
    wifiListView: TListView;
    WebBrowser1: TWebBrowser;
    GMMap1: TGMMap;
    GMMarker1: TGMMarker;
    hotspotLabel: TLabel;
    locationLabel: TLabel;
    ListViewIPs: TListView;
    Panel1: TPanel;
    Splitter1: TSplitter;
    shiftTimer: TTimer;
    procedure ButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure wifiListViewDblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GMMap1AfterPageLoaded(Sender: TObject; First: Boolean);
    procedure shiftTimerTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    wifiHotSpotInfos:TwifiHotSpotInfos;
    procedure onExternalIPRequest(var Msg: TMessage);message WM_EXTENALIP;
    procedure CopyData(var Msg: TWMCopyData); message wm_CopyData;
    procedure OnWMUSER(var Message: TWMChar);message WM_USER;
  public
    { Public declarations }
  end;

var
  wifiMainForm: TwifiMainForm;
  //externalIP:string;

implementation

{$R *.dfm}

uses nduWlanAPI, nduWlanTypes, nduWinDot11, mySecSharedFuncUnit, strutils,
  ShLwApi, ShellApi, CommCtrl, MSHTML, Winapi.ActiveX,GMConstants,
  GMFunctionsVCL, ForceBindIPUnit, Winapi.WinSock, GeoIPHelper, MMSystem,
  EncStrings, infoUnit;

const
HTMLStr: String = //i put The code for the web page page wich load the google maps in a string const, you can use an external html file too or embed the page in a resource and then load in a stream
  '<html> '+
  '<head> '+
  '<meta name="viewport" content="initial-scale=1.0, user-scalable=yes" /> '+
  '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=true"></script> '+
  '<script type="text/javascript"> '+
  ''+
  ''+//Declare the globals vars to be used in the javascript functions
  '  var geocoder; '+
  '  var map;  '+
  '  var trafficLayer;'+
  '  var bikeLayer;'+
  ''+
  ''+
  '  function initialize() { '+
  '    geocoder = new google.maps.Geocoder();'+
  '    var latlng = new google.maps.LatLng(40.714776,-74.019213); '+ //Set the initial coordinates for the map
  '    var myOptions = { '+
  '      zoom: 13, '+
  '      center: latlng, '+
  '      mapTypeId: google.maps.MapTypeId.ROADMAP '+ //Set the default type map
  '    }; '+
  '    map = new google.maps.Map(document.getElementById("map_canvas"), myOptions); '+
  '    trafficLayer = new google.maps.TrafficLayer();'+ //Create the traffic Layer instance
  '    bikeLayer = new google.maps.BicyclingLayer();'+ //Create the Bicycling Layer instance
  '  } '+
  ''+
  ''+
  '  function codeAddress(address) { '+ //function to translate an address to coordinates and put and marker.
  '    if (geocoder) {'+
  '      geocoder.geocode( { address: address}, function(results, status) { '+
  '        if (status == google.maps.GeocoderStatus.OK) {'+
  '          map.setCenter(results[0].geometry.location);'+
  '          var marker = new google.maps.Marker({'+
  '              map: map,'+
  '              position: results[0].geometry.location'+
  '          });'+
  '        } else {'+
  '          alert("Geocode was not successful for the following reason: " + status);'+
  '        }'+
  '      });'+
  '    }'+
  '  }'+
  ''+
  ''+
  '  function GotoLatLng(Lat, Lang) { '+ //Set the map in the coordinates and put a marker
  '   var latlng = new google.maps.LatLng(Lat,Lang);'+
  '   map.setCenter(latlng);'+
  '   var marker = new google.maps.Marker({'+
  '      position: latlng, '+
  '      map: map,'+
  '      title:Lat+","+Lang'+
  '  });'+
  '  }'+
  ''+
  ''+
  '  function TrafficOn()   { trafficLayer.setMap(map); }'+ //Activate the Traffic layer
  ''+
  '  function TrafficOff()  { trafficLayer.setMap(null); }'+
  ''+''+
  '  function BicyclingOn() { bikeLayer.setMap(map); }'+//Activate the Bicycling layer
  ''+
  '  function BicyclingOff(){ bikeLayer.setMap(null);}'+
  ''+
  '  function StreetViewOn() { map.set("streetViewControl", true); }'+//Activate the streeview control
  ''+
  '  function StreetViewOff() { map.set("streetViewControl", false); }'+
  ''+
  ''+'</script> '+
  '</head> '+
  '<body onload="initialize()"> '+
  '  <div id="map_canvas" style="width:100%; height:100%"></div> '+
  '</body> '+
  '</html> ';

HTMLStr2: String = //i put The code for the web page page wich load the google maps in a string const, you can use an external html file too or embed the page in a resource and then load in a stream
  '<html> '+
  '<head> '+
  '<meta name="viewport" content="initial-scale=1.0, user-scalable=yes" /> '+
  '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=true"></script> '+
  '<script type="text/javascript"> '+
  ''+
  ''+//Declare the globals vars to be used in the javascript functions
  '  var geocoder; '+
  '  var map;  '+
  '  var trafficLayer;'+
  '  var bikeLayer;'+
  ''+
  ''+
  '  function initMap() { '+
//  '    geocoder = new google.maps.Geocoder();'+
  '    var latlng = new google.maps.LatLng(%lat,%long); '+ //Set the initial coordinates for the map
  '    var myOptions = { '+
  '      zoom: 13, '+
  '      center: latlng '+
//  '      ,mapTypeId: google.maps.MapTypeId.ROADMAP '+ //Set the default type map
  '    }; '+
  '    map = new google.maps.Map(document.getElementById("map_canvas"), myOptions); '+
//  '   map.setCenter(latlng);'+
//  '   var marker = new google.maps.Marker({'+
//  '      position: latlng, '+
//  '      map: map,'+
//  '      title:","'+
//  '   });'+
//    
    'var marker = new google.maps.Marker({'+
        //   
    '    position: latlng,'+
        //       . (       )
    '    map: map,'+
        //    -         
     '   title: '' :  '''+
    '});'+
  '  } '+
  ''+
  ''+
  ''+'</script> '+
  '</head> '+
  '<body onload="initMap()"> '+
  '  <div id="map_canvas" style="width:100%; height:100%"></div> '+
  '</body> '+
  '</html> ';

var
  bm            :TBitMap;
  shift         :LongInt;
  maxshift      :LongInt;
  run_s         :String;
  timerID       :LongInt;
  infoText:string;
  systemLangID:LangID;

//  windows
function WhichLanguage:string;
var
  ID: LangID;
  Language: array [0..100] of char;
begin
  ID := GetSystemDefaultLangID;
  VerLanguageName(ID, Language, 100);
  Result := string(Language);
end;

//  
procedure OnTimer(uTimerID, uMsg, dwUser, dw1, dw2 :LongInt);stdcall;
begin
  SendMessage(wifiMainForm.Handle,WM_USER,0,0);
end;

procedure TwifiMainForm.ButtonClick(Sender: TObject);
var hWlan: THandle;
  pInterfaceList: Pndu_WLAN_INTERFACE_INFO_LIST;
  i: Integer;
  guid: TGUID;
  //wifiHotSpotInfos:TwifiHotSpotInfos;
  FormatSettings: TFormatSettings;
  lat,lng:real;
  localIPs:TStringList;
  cmd: string;
  li: TListItem;
begin
wifiHotSpotInfos.Clear;
if getWLANInterfaces(hWlan,pInterfaceList) then begin
  for i := 0 to pInterfaceList^.dwNumberOfItems-1 do begin
    guid := pInterfaceList^.InterfaceInfo[i].InterfaceGuid;
    GetBSSIDList(wifiHotSpotInfos,hWlan,guid);
  end;
  freeWLANInterfaces(pInterfaceList);
end;

for I := 0 to wifiHotSpotInfos.Count-1 do begin
  with wifiListView.Items.Add do begin
    Caption:=wifiHotSpotInfos[i].ssid;
    SubItems.Add(wifiHotSpotInfos[i].mac);
    SubItems.Add(wifiHotSpotInfos[i].gps.latitude+','+
      wifiHotSpotInfos[i].gps.longitude);
    SubItems.Add('https://www.google.com/maps/search/'+
      wifiHotSpotInfos[i].gps.latitude+','+
      wifiHotSpotInfos[i].gps.longitude);
  end;
end;
AutoWidth(wifiListView);
//(WebBrowser.Document as IHTMLDocument2).parentWindow.execScript(Format('GotoLatLng(%s,%s)',
//  [wifiHotSpotInfos[0].gps.latitude,wifiHotSpotInfos[0].gps.longitude]), 'JavaScript');//Call the function GotoLatLng to go the coordinates
//WB_LoadHTML(WebBrowser,
//  replacestr(replacestr(HTMLStr2,'%lat',wifiHotSpotInfos[0].gps.latitude),
//    '%long',wifiHotSpotInfos[0].gps.longitude));

FormatSettings:=TFormatSettings.Create;
FormatSettings.DecimalSeparator:='.';
GMMarker1.Clear;
for i := 0 to wifiHotSpotInfos.Count-1 do begin
  if (wifiHotSpotInfos[i].gps.latitude='*') or
    (wifiHotSpotInfos[i].gps.longitude='*') then continue;
  GMMarker1.Add(strTOFloat(wifiHotSpotInfos[i].gps.latitude,FormatSettings),
    strTOFloat(wifiHotSpotInfos[i].gps.longitude,FormatSettings),
    wifiHotSpotInfos[i].ssid+'('+wifiHotSpotInfos[i].mac+')'   ).MarkerType := mtStandard;
end;
GMMarker1.ZoomToPoints;
//GMMap.DoMap;

ListViewIPs.Clear;
localIPs:=TStringList.Create;
try
  localIPs.text:=GetLocalIPs;
  for I := 0 to localIPs.Count-1 do begin
    li:=ListViewIPs.Items.Add;
    li.Caption:=localIPs[i];
    //externalIP:='';
    cmd:=addForceBindIPToCMD(appdir+getExternalIPPath,localIPs[i],
      intToStr(self.Handle)+' '+localIPs[i]);
    ExecWaitShowPath(cmd,0);
    //Application.ProcessMessages;
//    if externalIP.StartsWith(getExternalIPsubstr) then begin
//      li.SubItems.Add(externalIP.Substring(getExternalIPsubstr.length));
//    end;
    //externalIP:='';
  end;
  AutoWidth(ListViewIPs);
finally
  freeandnil(localIPs);
end;
end;

procedure TwifiMainForm.CopyData(var Msg: TWMCopyData);
var sMsg: String;
  localIP: string;
  externalIP: string;
  i: Integer;
begin
//  if IsIconic(Application.Handle) then
//    Application.Restore;
  sMsg := PChar(Msg.CopyDataStruct.lpData);
  //externalip := sMsg;
  //    if externalIP.StartsWith(getExternalIPsubstr) then begin
//      li.SubItems.Add(externalIP.Substring(getExternalIPsubstr.length));
//    end;
  if sMsg.StartsWith(getExternalIPsubstr) then begin
    sMsg:=sMsg.Substring(getExternalIPsubstr.Length);
    localIP:=sMsg.Substring(sMsg.IndexOf('-')+1);
    externalIP:=sMsg.Substring(0,sMsg.IndexOf('-'));
    for i := 0 to ListViewIPs.Items.Count-1 do begin
      if ListViewIPs.Items[i].Caption=localIP then begin
        ListViewIPs.Items[i].SubItems.Add(externalIP);
        break;
        AutoWidth(ListViewIPs);
      end;
    end;
  end;
end;

procedure TwifiMainForm.FormCreate(Sender: TObject);
begin
WebBrowser2IE9;
wifiHotSpotInfos:=TwifiHotSpotInfos.Create;
//WB_LoadHTML(WebBrowser,HTMLStr);

  systemLangID:=GetSystemDefaultLangID;

  // 
  bm:=TBitMap.Create;
  bm.Width:=self.Width-36;
  bm.Height:=40;
  shift:=bm.Width;
  if systemLangID=1049 then
    run_s:=' Double SSH Tunnel Manager'
  else
    run_s:='Double SSH Tunnel Manager Project';
  with bm.Canvas.Font do begin
    name:='Courier New';
    Size:=26  ;
    Style:=[fsBold];
    Color:=clRed;
  end;
  maxshift:=-bm.Canvas.TextWidth(run_s);
//  if timeBeginPeriod(1)<>TIMERR_NOERROR then Caption:='Error timeBeginPeriod';
//  timerID:=timeSetEvent(5,0,@OnTimer,0,TIME_PERIODIC or TIME_CALLBACK_FUNCTION);

  //
  if systemLangID=1049 then begin
    Caption:=' ';
    hotspotLabel.Caption:='  WiFi ';
    locationLabel.Caption:='  IP';
    wifiListView.Column[3].Caption:='';
    ListViewIPs.Column[0].Caption:=' IP';
    ListViewIPs.Column[1].Caption:=' IP';
    ListViewIPs.Column[0].Caption:='';
  end;

  if systemLangID=1049 then begin
    infoText:=EncString(CINFO_RU_STRING,CINFO_RU_KEY,false)
  end else begin
    infoText:=EncString(CINFO_EN_STRING,CINFO_EN_KEY,false)
  end;
end;

procedure TwifiMainForm.FormDestroy(Sender: TObject);
begin
freeandnil(wifiHotSpotInfos);
end;

procedure TwifiMainForm.FormShow(Sender: TObject);
var
  infoForm: TinfoForm;
begin
infoForm:=TinfoForm.create(self);
try
  WB_LoadHTML(infoForm.WebBrowser,infoText);
  infoForm.Top:=(Screen.Height-infoForm.Height) div 2;
  infoForm.left:=(Screen.Width-infoForm.Width) div 2;
  infoForm.ShowModal;
finally
  infoForm.Free;
end;
end;

procedure TwifiMainForm.GMMap1AfterPageLoaded(Sender: TObject; First: Boolean);
begin
if  First  then //    
  begin
    GMMap1.DoMap; //  
  end;
end;

procedure TwifiMainForm.wifiListViewDblClick(Sender: TObject);
begin
  if wifiListView.Selected=nil then exit;
  if not PathIsURL(PChar(wifiListView.Selected.SubItems[2])) then exit;
  ShellExecute(self.WindowHandle, 'open',
    PChar(wifiListView.Selected.SubItems[2]),
    nil, nil, SW_SHOWNORMAL);
end;

procedure TwifiMainForm.onExternalIPRequest(var Msg: TMessage);
var
  GInitData: WSAData;
  localIP: string;
  externalIP: PAnsiChar;
  i: Integer;
begin
  WSAStartup($101, GInitData);
  localIP:=inet_ntoa(TInAddr(Msg.WParam));
  externalIP:=inet_ntoa(TInAddr(Msg.LParam));
  if externalIP='127.0.0.1' then externalIP:='-';
  for i := 0 to ListViewIPs.Items.Count-1 do begin
    if ListViewIPs.Items[i].Caption=localIP then begin
      ListViewIPs.Items[i].SubItems.Add(externalIP);
      if externalIP<>'-' then begin
        ListViewIPs.Items[i].SubItems.Add(GetCountryNameGeoIP(externalIP)+', '+
          GetCityNameGeoIP(externalIP));
      end;
      AutoWidth(ListViewIPs);
      break;
    end;
  end;
  WSACleanup;
end;

procedure TwifiMainForm.OnWMUSER(var Message: TWMChar);
begin
  bm.Canvas.TextRect(rect(0,0,bm.Width,bm.Height),shift,0,run_s);
  dec(shift);
  if shift<maxshift then shift:=bm.Width;
  Canvas.Draw(10,10,bm);
end;

procedure TwifiMainForm.shiftTimerTimer(Sender: TObject);
begin
  bm.Canvas.TextRect(rect(0,0,bm.Width,bm.Height),shift,0,run_s);
  dec(shift);
  if shift<maxshift then shift:=bm.Width;
  Canvas.Draw(10,10,bm);
//  SendMessage(Handle,WM_USER,0,0);
end;

end.
